local LibQTip = LibStub("LibQTip-1.0");

GSE_PLAYER_WINDOW_GEAR_BUTTON_HEIGHT = 47;

local armorSpecializations = {
	["MAGE"] = {
		["type"] = "Cloth",
	},
	["PRIEST"] = {
		["type"] = "Cloth",
	},
	["WARLOCK"] = {
		["type"] = "Cloth",
	},
	["DRUID"] = {
		["type"] = "Leather",
	},
	["ROGUE"] = {
		["type"] = "Leather",
	},
	["HUNTER"] = {
		["type"] = "Mail",
	},
	["SHAMAN"] = {
		["type"] = "Mail",
	},
	["DEATHKNIGHT"] = {
		["type"] = "Plate",
	},
	["PALADIN"] = {
		["type"] = "Plate",
	},
	["WARRIOR"] = {
		["type"] = "Plate",
	},
};

-- This was originally copied from Blizzard_TalentUI.lua.
-- /run for i = 1, 3 do local r, g, b = _G["PlayerTalentFramePanel"..i.."HeaderBackground"]:GetVertexColor() print(format("%.2f, %.2f, %.2f", r, g, b)) end
local TALENT_INFO = {
	["default"] = {
		[1] = {
			color = {r=1.0, g=0.72, b=0.1},
		},
		[2] = {
			color = {r=1.0, g=0.0, b=0.0},
		},
		[3] = {
			color = {r=0.3, g=0.5, b=1.0},
		}
	},
	
	["DEATHKNIGHT"] = {
		[1] = {
			-- Blood
			color = {r=1.0, g=0.0, b=0.0},
		},
		[2] = {
			-- Frost
			color = {r=0.3, g=0.5, b=1.0},
		},
		[3] = {
			-- Unholy
			color = {r=0.2, g=0.8, b=0.2},
		}
	},
	
	["DRUID"] = {
		[1] = {
			-- Balance
			color = {r=0.8, g=0.3, b=0.8},
		},
		[2] = {
			-- Feral
			color = {r=1.0, g=0.0, b=0.0},
		},
		[3] = {
			-- Restoration
			color = {r=0.4, g=0.8, b=0.2},
		}	
	},
	
	["HUNTER"] = {
		[1] = {
			-- Beast Mastery
			color = {r=0.3, g=0.0, b=1.0},
		},
		[2] = {
			-- Marksmanship
			color = {r=0.8, g=0.2, b=0.8},
		},
		[3] = {
			-- Survival
			color = {r=0.0, g=1.0, b=0.6},
		}
	},
	
	["MAGE"] = {
		[1] = {
			-- Arcane
			color = {r=1.0, g=0.72, b=0.1},
		},
		[2] = {
			-- Fire
			color = {r=1.0, g=0.0, b=0.0},
		},
		[3] = {
			-- Frost
			color = {r=0.3, g=0.5, b=1.0},
		}
	},
	
	["PALADIN"] = {
		[1] = {
			-- Holy
			color = {r=1.0, g=0.5, b=0.0},
		},
		[2] = {
			-- Protection
			color = {r=0.3, g=0.5, b=1.0},
		},
		[3] = {
			-- Retribution
			color = {r=1.0, g=0.0, b=0.0},
		}
	},
	
	["PRIEST"] = {
		[1] = {
			-- Discipline
			color = {r=1.0, g=0.5, b=0.0},
		},
		[2] = {
			-- Holy
			color = {r=0.6, g=0.6, b=1.0},
		},
		[3] = {
			-- Shadow
			color = {r=0.7, g=0.4, b=0.8},
		}
	},
	
	["ROGUE"] = {
		[1] = {
			-- Assassination
			color = {r=0.5, g=0.8, b=0.5},
		},
		[2] = {
			-- Combat
			color = {r=1.0, g=0.5, b=0.0},
		},
		[3] = {
			-- Subtlety
			color = {r=0.3, g=0.5, b=1.0},
		}
	},
	
	["SHAMAN"] = {
		[1] = {
			-- Elemental
			color = {r=0.8, g=0.2, b=0.8},
		},
		[2] = {
			-- Enhancement
			color = {r=0.3, g=0.5, b=1.0},
		},
		[3] = {
			-- Restoration
			color = {r=0.2, g=0.8, b=0.4},
		}
	},
	
	["WARLOCK"] = {
		[1] = {
			-- Affliction
			color = {r=1.0, g=0.6, b=1.0},
		},
		[2] = {
			-- Demonology
			color = {r=1.0, g=0.0, b=0.0},
		},
		[3] = {
			-- Destruction
			color = {r=1.0, g=0.5, b=0.0},
		}
	},
	
	["WARRIOR"] = {
		[1] = {
			-- Arms
			color = {r=1.0, g=0.72, b=0.1},
		},
		[2] = {
			-- Fury
			color = {r=1.0, g=0.0, b=0.0},
		},
		[3] = {
			-- Protection
			color = {r=0.3, g=0.5, b=1.0},
		}
	},
	
	["PET_409"] = {
		-- Tenacity
		[1] = {
			color = {r=1.0, g=0.1, b=1.0},
		}
	},
	
	["PET_410"] = {
		-- Ferocity
		[1] = {
			color = {r=1.0, g=0.0, b=0.0},
		}
	},
	
	["PET_411"] = {
		-- Cunning
		[1] = {
			color = {r=0.0, g=0.6, b=1.0},
		}
	},
};

local requiredEnchants = {
	["INVTYPE_HEAD"] = true,
	["INVTYPE_SHOULDER"] = true,
	["INVTYPE_CHEST"] = true,
	["INVTYPE_ROBE"] = true,
	["INVTYPE_LEGS"] = true,
	["INVTYPE_FEET"] = true,
	["INVTYPE_WRIST"] = true,
	["INVTYPE_HAND"] = true,
	["INVTYPE_CLOAK"] = true,
	["INVTYPE_WEAPON"] = true,
	["INVTYPE_SHIELD"] = true,
	["INVTYPE_2HWEAPON"] = true,
	["INVTYPE_WEAPONMAINHAND"] = true,
	["INVTYPE_WEAPONOFFHAND"] = true,
};

local shownInventorySlots = {
	{["slot"] = "HeadSlot", ["name"] = "Head"},
	{["slot"] = "NeckSlot", ["name"] = "Neck"},
	{["slot"] = "ShoulderSlot", ["name"] = "Shoulders"},
	{["slot"] = "BackSlot", ["name"] = "Back"},
	{["slot"] = "ChestSlot", ["name"] = "Chest"},
	{["slot"] = "ShirtSlot", ["name"] = "Shirt"},
	{["slot"] = "TabardSlot", ["name"] = "Tabard"},
	{["slot"] = "WristSlot", ["name"] = "Wrists"},
	{["slot"] = "HandsSlot", ["name"] = "Hands"},
	{["slot"] = "WaistSlot", ["name"] = "Waist"},
	{["slot"] = "LegsSlot", ["name"] = "Legs"},
	{["slot"] = "FeetSlot", ["name"] = "Feet"},
	{["slot"] = "Finger0Slot", ["name"] = "Ring"},
	{["slot"] = "Finger1Slot", ["name"] = "Ring"},
	{["slot"] = "Trinket0Slot", ["name"] = "Trinket"},
	{["slot"] = "Trinket1Slot", ["name"] = "Trinket"},
	{["slot"] = "MainHandSlot", ["name"] = "Main Hand"},
	{["slot"] = "SecondaryHandSlot", ["name"] = "Off Hand"},
	{["slot"] = "RangedSlot", ["name"] = "Ranged"},
};

function GSE_PlayerWindow_OnLoad(self)
	tinsert(UISpecialFrames, self:GetName());
	
	self:RegisterForDrag("LeftButton");

	self.TitleText:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

	PanelTemplates_SetNumTabs(self, 3);
	PanelTemplates_SetTab(self, 1);

	self.talentGroup = nil;
	
	GSE_PlayerWindow_UpdateWindowSize(self);
	
	local texture = DressUpTexturePath();
	_G[self:GetName().."TabPage1ModelFrameBackgroundTopLeft"]:SetTexture(texture..1);
	_G[self:GetName().."TabPage1ModelFrameBackgroundTopRight"]:SetTexture(texture..2);
	_G[self:GetName().."TabPage1ModelFrameBackgroundBotLeft"]:SetTexture(texture..3);
	_G[self:GetName().."TabPage1ModelFrameBackgroundBotRight"]:SetTexture(texture..4);
	
	_G[self:GetName().."TabPage1GuildName"]:SetJustifyH("RIGHT");
	_G[self:GetName().."TabPage1PlayerGender"]:SetJustifyH("RIGHT");
	_G[self:GetName().."TabPage1PlayerUpdateTime"]:SetJustifyH("RIGHT");
	_G[self:GetName().."TabPage1PlayerAudit"]:SetJustifyH("LEFT");
end

function GSE_PlayerWindow_GearEntry_OnEnter(self)
	if self.item then
		ItemRefTooltip:SetOwner(self, "ANCHOR_RIGHT");
		ItemRefTooltip:SetHyperlink(self.item);
		ItemRefTooltip:Show();
		if self.borderAlert then
			self:SetBackdropBorderColor(1.0, 0.0, 0.0, 1.0);
		else
			self:SetBackdropBorderColor(0.0, 0.694, 0.941, 1.0);
		end
		if IsShiftKeyDown() then
			GameTooltip_ShowCompareItem(ItemRefTooltip);
		end
	end
end

function GSE_PlayerWindow_GearEntry_OnLeave(self)
	ItemRefTooltip:Hide();
	if self.item then
		if self.borderAlert then
			self:SetBackdropBorderColor(1.0, 0.0, 0.0, 0.7);
		else
			self:SetBackdropBorderColor(0.0, 0.694, 0.941, 0.36);
		end
	end
end

function GSE_PlayerWindow_GearEntry_OnClick(self)
	if self.item then
		if IsModifiedClick("CHATLINK") then
			ChatEdit_InsertLink(self.item)
		elseif IsModifiedClick("DRESSUP") then
			DressUpItemLink(self.item);
		end
	end
end

function GSE_PlayerWindow_GearEntry_OnUpdate(self, elapsed)
	if self.timeSinceLastUpdate == nil then
		self.timeSinceLastUpdate = 0.0;
	end
	
	self.timeSinceLastUpdate = self.timeSinceLastUpdate + elapsed;
	
	if self.timeSinceLastUpdate > 0.5 then
		if IsModifiedClick("COMPAREITEMS") then
			GameTooltip_ShowCompareItem(ItemRefTooltip);
		else
			local shoppingTooltip1, shoppingTooltip2, shoppingTooltip3 = unpack(ItemRefTooltip.shoppingTooltips);
			shoppingTooltip1:Hide();
			shoppingTooltip2:Hide();
			shoppingTooltip3:Hide();	
		end
	end
end

function GSE_PlayerWindow_GearEntryGem_OnEnter(self)
	if self.item then
		ItemRefTooltip:SetOwner(self, "ANCHOR_RIGHT");
		ItemRefTooltip:SetHyperlink(self.item);
		ItemRefTooltip:Show();
	else
		GSE_PlayerWindow_GearEntry_OnEnter(self:GetParent());
		GSE_PlayerWindow_Gear_Update(self:GetParent():GetParent());
	end
end

function GSE_PlayerWindow_GearEntryGem_OnLeave(self)
	if self.item then
		ItemRefTooltip:Hide();
	end
end

function GSE_PlayerWindow_GearEntryGem_OnClick(self)
	if self.item then
		if IsModifiedClick("CHATLINK") then
			ChatEdit_InsertLink(self.item)
		end
	else
		GSE_PlayerWindow_GearEntry_OnClick(self:GetParent());
	end
end

function GSE_PlayerWindow_Gear_Update(scrollFrame)
	local playerWindow = scrollFrame:GetParent():GetParent();
	local playerData = playerWindow.playerData;
	local talentGroup = playerWindow.talentGroup;
	if playerData and playerData["inventory"] and playerData["inventory"][talentGroup] then
		local offset = FauxScrollFrame_GetOffset(scrollFrame);
		local buttonPrefix = scrollFrame:GetParent():GetName().."GearEntry";
		local requiredSlots = {
			["HeadSlot"] = true,
			["NeckSlot"] = true, 
			["ShoulderSlot"] = true, 
			["BackSlot"] = true, 
			["ChestSlot"] = true, 
			["WristSlot"] = true, 
			["HandsSlot"] = true, 
			["WaistSlot"] = true, 
			["LegsSlot"] = true, 
			["FeetSlot"] = true, 
			["Finger0Slot"] = true, 
			["Finger1Slot"] = true, 
			["Trinket0Slot"] = true, 
			["Trinket1Slot"] = true,
			["MainHandSlot"] = true,
			["SecondaryHandSlot"] = true,
			["RangedSlot"] = true,
		};
		for i = 1, #shownInventorySlots do
			local buttonName = buttonPrefix..i;
			if not _G[buttonName] then
				_G[buttonName] = CreateFrame("Button", buttonName, scrollFrame, "GSE_GearEntryButtonTemplate");
				_G[buttonName]:SetBackdropColor(0, 0.090, 0.222, 0.6);
			end
			
			local button = _G[buttonName];			
			
			button:SetBackdropBorderColor(0.0, 0.694, 0.941, 0.36);

			button:ClearAllPoints();
			button:SetPoint("TOPLEFT", scrollFrame, "TOPLEFT", 8, (-i + offset + 1) * GSE_PLAYER_WINDOW_GEAR_BUTTON_HEIGHT);
			button:SetPoint("BOTTOMRIGHT", scrollFrame, "TOPRIGHT", -1, (-i + offset) * GSE_PLAYER_WINDOW_GEAR_BUTTON_HEIGHT);
			
			if i > offset and i <= offset + 7 then
				local slot = shownInventorySlots[i]["slot"];
				local item = playerData["inventory"][talentGroup][slot];

				button.item = item;
				
				_G[buttonName.."ItemIconTexture"]:SetTexture(nil);
				_G[buttonName.."ItemLevel"]:SetText("");
				_G[buttonName.."ItemName"]:SetText("");
				_G[buttonName.."ItemEnchant"]:SetText("");

				button.borderAlert = false;

				if item then
					_G[buttonName.."ItemSlot"]:SetText(shownInventorySlots[i]["name"]);

					local itemName, _, itemRarity, itemLevel, _, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(item);
										
					if itemName then
						_G[buttonName.."ItemIconTexture"]:SetTexture(itemTexture);
						_G[buttonName.."ItemName"]:SetFormattedText("%s%s", select(4, GetItemQualityColor(itemRarity)), itemName);
						
						if itemLevel > 0 then
							_G[buttonName.."ItemLevel"]:SetFormattedText("|cFF0050C0Level %d", itemLevel);
						end
					
						if playerData["level"] >= 40 and slot ~= "BackSlot" and itemType == "Armor" and (itemSubType == "Cloth" or itemSubType == "Leather" or itemSubType == "Mail" or itemSubType == "Plate") then
							if itemSubType ~= armorSpecializations[playerData["class"]]["type"] then
								button.borderAlert = true;
							end
						end

						local _, _, enchantId, jewel1, jewel2, jewel3, jewel4 = strsplit(":", item);
						local jewels = {jewel1, jewel2, jewel3, jewel4};

						if enchantId ~= "0" then						
							_G[buttonName.."ItemEnchant"]:SetText("Enchanted.");
						elseif requiredEnchants[itemEquipLoc] then
							_G[buttonName.."ItemEnchant"]:SetText("|cFFFF0000No enchantment.");
							button.borderAlert = true;
						else
							_G[buttonName.."ItemEnchant"]:SetText("|cFFA0A0A0No enchantment.");
						end

						local reforged = false;
						local enchantment = nil;
						
						-- I really hate scanning the tooltip. Is there a way to turn enchantId into something useful?
						GSE_HiddenTooltip:ClearLines();
						GSE_HiddenTooltip:SetHyperlink(item);
						for i = 1, GSE_HiddenTooltip:NumLines() do
							local red, green, blue = _G["GSE_HiddenTooltipTextLeft"..i]:GetTextColor();
							if red == 0 and green > 0.99 and blue == 0 then
								local text = _G["GSE_HiddenTooltipTextLeft"..i]:GetText();
								if string.find(text:lower(), "reforge") ~= nil then
									reforged = true;
								elseif text:lower() ~= "heroic" then
									if enchantId ~= "0" then
										enchantment = text;
									end
									break
								end		
							end
						end
						
						if enchantment then
							_G[buttonName.."ItemEnchant"]:SetText(enchantment);
						end
						
						local totalGemSockets = GSE_TotalGemSockets(item);
						if itemEquipLoc == "INVTYPE_WAIST" then
							totalGemSockets = totalGemSockets + 1;
						end
						
						if GSE_TotalGems(item) < totalGemSockets then
							button.borderAlert = true;
						end

						for j = 1, 4 do
							local gemName, gemLink = GetItemGem(item, j);
							_G[buttonName.."Gem"..j].item = gemLink;
							if gemName then
								local gemName, _, _, _, _, _, _, _, _, gemTexture = GetItemInfo(gemLink);
								_G[buttonName.."Gem"..j.."Texture"]:SetTexture(gemTexture);
								_G[buttonName.."Gem"..j]:Show();
							elseif jewels[j] ~= "0" then
								_G[buttonName.."Gem"..j.."Texture"]:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
								_G[buttonName.."Gem"..j]:Show();
							else
								_G[buttonName.."Gem"..j]:Hide();
							end
						end
					else
						_G[buttonName.."ItemIconTexture"]:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
						_G[buttonName.."ItemName"]:SetFormattedText("|cFFFF0000You've never seen this item.");
					end
				else
					-- The slot is empty.
					_G[buttonName.."ItemSlot"]:SetFormattedText("|cFFA0A0A0%s", shownInventorySlots[i]["name"]);
					button:SetBackdropBorderColor(1.0, 1.0, 1.0, 0.1);
					
					if requiredSlots[slot] then
						button.borderAlert = true;
						if slot == "SecondaryHandSlot" and playerData["inventory"][talentGroup]["MainHandSlot"] then
							local _, _, _, _, _, _, _, _, mhEquipLoc = GetItemInfo(playerData["inventory"][talentGroup]["MainHandSlot"]);
							if mhEquipLoc == "INVTYPE_2HWEAPON" then
								-- There's no other possible reason to set an alert.
								button.borderAlert = false; 
							end
						end
					end
				end
				
				if button.borderAlert then
					button:SetBackdropBorderColor(1.0, 0.0, 0.0, 0.7);
				end
					
				button:Show();
			else
				button:Hide();
			end
		end
		FauxScrollFrame_Update(scrollFrame, #shownInventorySlots + 1, 7, GSE_PLAYER_WINDOW_GEAR_BUTTON_HEIGHT);
	else
		FauxScrollFrame_Update(scrollFrame, 0, 0, GSE_PLAYER_WINDOW_GEAR_BUTTON_HEIGHT);
	end
end

function GSE_PlayerWindow_UpdateWindowSize(self)
	local tabFrame = _G[self:GetName().."TabPage"..self.selectedTab];
	self:SetWidth(tabFrame:GetWidth());
	self:SetHeight(tabFrame:GetHeight() + 92);
end

function GSE_PlayerWindow_SpecTab_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	if self:GetID() == 1 then
		GameTooltip:AddLine("Primary Talents");
	else
		GameTooltip:AddLine("Secondary Talents");
	end
	local parent = self:GetParent();
	if parent.playerData["talents"] then
		if self:GetID() == parent.playerData["talentGroup"] then
			GameTooltip:AddLine("These are the player's active talents.", 0, 1, 0, 1);
		end
		local primaryTab = parent.playerData["talents"][self:GetID()]["primaryTab"];
		for i = 1, 3 do
			local name = gGSETalentTreeData[parent.playerData["class"]][i]["name"];
			if i == primaryTab then
				GameTooltip:AddDoubleLine(name, parent.playerData["talents"][self:GetID()][i]["pointsSpent"], 0, 1, 0, 0, 1, 0);
			else
				GameTooltip:AddDoubleLine(name, parent.playerData["talents"][self:GetID()][i]["pointsSpent"], 1, 1, 1, 1, 1, 1);
			end
		end
		GameTooltip:Show();
	else
		GameTooltip:AddLine("|cFFA0A0A0Talent data not gathered.");
	end
	GameTooltip:Show();
end

function GSE_PlayerWindow_SpecTab_OnClick(self)
	PlaySound("igCharacterInfoTab");
	
	local parent = self:GetParent();
	
	for i = 1, 2 do
		local tab = _G[parent:GetName().."SpecTab"..i];
		tab:SetChecked(nil);
		if tab == self then
			parent.talentGroup = i;
			tab:SetChecked(true);
		end
	end
	
	GSE_PlayerWindow_Refresh(parent);
end

function GSE_PlayerWindow_TabButtonClick(self)
	PlaySound("igCharacterInfoTab");
	PanelTemplates_SetTab(self:GetParent(), self:GetID());
	
	GSE_PlayerWindow_Refresh(self:GetParent());
end

function GSE_PlayerWindow_Refresh(self)
	for i = 1, 3 do
		if i == self.selectedTab then
			_G[self:GetName().."TabPage"..i]:Show();
		else
			_G[self:GetName().."TabPage"..i]:Hide();
		end
	end

	if not self.playerData then
		return;
	end
	
	-- Title
	self.TitleText:SetText(self.playerData["name"].."-"..self.playerData["realm"]);
	
	-- Portrait
	if self.playerData["talents"] and self.playerData["talents"][self.playerData["talentGroup"]]["primaryTab"] then
		local icon = gGSETalentTreeData[self.playerData["class"]][self.playerData["talents"][self.playerData["talentGroup"]]["primaryTab"]]["iconTexture"];
		_G[self:GetName().."Portrait"]:SetTexCoord(0, 1, 0, 1);
		SetPortraitToTexture(_G[self:GetName().."Portrait"], icon);
	else
		_G[self:GetName().."Portrait"]:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles");
		_G[self:GetName().."Portrait"]:SetTexCoord(unpack(CLASS_ICON_TCOORDS[self.playerData["class"]]));
	end
	
	-- Spec Tabs
	if self.playerData["talents"] and self.playerData["talents"][1]["primaryTab"] then
		local icon = gGSETalentTreeData[self.playerData["class"]][self.playerData["talents"][1]["primaryTab"]]["iconTexture"];
		_G[self:GetName().."SpecTab1"]:SetNormalTexture(icon);
	else
		_G[self:GetName().."SpecTab1"]:SetNormalTexture("Interface\\Icons\\Ability_Marksmanship");
	end
	if self.playerData["talents"] and self.playerData["talents"][2]["primaryTab"] then
		local icon = gGSETalentTreeData[self.playerData["class"]][self.playerData["talents"][2]["primaryTab"]]["iconTexture"];
		_G[self:GetName().."SpecTab2"]:SetNormalTexture(icon);
	else
		_G[self:GetName().."SpecTab2"]:SetNormalTexture("Interface\\Icons\\Ability_Marksmanship");
	end
	
	if not self.talentGroup and self.playerData["talents"] then
		self.talentGroup = self.playerData["talentGroup"];
		for i = 1, 2 do
			_G[self:GetName().."SpecTab"..i]:SetChecked(i == self.talentGroup);
		end
	end

	GSE_PlayerWindow_UpdateOverview(self);
	GSE_PlayerWindow_UpdateTalents(self);
	
	GSE_PlayerWindow_Gear_Update(_G[self:GetName().."TabPage2GearScrollFrame"]);

	GSE_PlayerWindow_UpdateWindowSize(self);
end

function GSE_PlayerWindow_OnShow(self)
	PlaySound("igCharacterInfoOpen");
	PanelTemplates_SetTab(self, 1);
	
	self.talentGroup = nil;
		
	GSE_PlayerWindow_Refresh(self);

	GSE_PlayerWindow_UpdateWindowSize(self);

	gGSEPlayerWindows[self:GetName()] = true;
end

function GSE_PlayerWindow_OnHide(self)
	PlaySound("igCharacterInfoClose");

	gGSEPlayerWindows[self:GetName()] = nil;
	self:SetParent(nil);
	tinsert(gGSEReusablePlayerWindows, self);
end

function GSE_PlayerWindow_UpdateOverview(self)
	-- This function is getting pretty long.

	if not self.playerData then
		return;
	end

	_G[self:GetName().."TabPage1ModelFrameBackgroundOverlay"]:SetAlpha(0.7);
	
	local model = _G[self:GetName().."TabPage1ModelFrame"];

	model:SetUnit("player");
	
	model:Undress();
	
	_G[self:GetName().."TabPage1PlayerName"]:SetFormattedText("%s", self.playerData["name"]);
	
	if self.playerData["guildName"] then
		_G[self:GetName().."TabPage1GuildName"]:SetFormattedText("|cFF8060A0<%s> |cFFA0A0A0%s", self.playerData["guildName"], self.playerData["guildRankName"]);
	else
		_G[self:GetName().."TabPage1GuildName"]:SetText("");
	end
	
	if self.playerData["sex"] == 3 then
		_G[self:GetName().."TabPage1PlayerGender"]:SetFormattedText("|cFFFF80FFFemale");
	else
		_G[self:GetName().."TabPage1PlayerGender"]:SetFormattedText("|cFF0080FFMale");
	end		
	
	_G[self:GetName().."TabPage1PlayerClass"]:SetFormattedText("|cFFA0A0A0%d |cFFFFFFFF%s %s%s", self.playerData["level"], self.playerData["race"], GSE_ClassColorString(self.playerData["class"]), self.playerData["class"]);

	local gearAudit = "|cFFA0A0A0Inventory data not gathered.";
	local armorAudit = "|cFFA0A0A0Inventory data not gathered.";
	local gemAudit = "|cFFA0A0A0Inventory data not gathered.";
	local enchantAudit = "|cFFA0A0A0Inventory data not gathered.";
	local talentAudit = "|cFFA0A0A0Talent data not gathered.";
	
	if self.playerData["talents"] then
		local missingTalents = false;
		if self.talentGroup then
			talentAudit = "|cFF00FF00All available points have been assigned to this spec.";
		end
		local specNames = {"Undecided", "Undecided"};
		local specColors = {"FFA0A0A0", "FFA0A0A0"};
		for spec = 1, 2 do
			local pointsSpent = self.playerData["talents"][spec][1]["pointsSpent"] + self.playerData["talents"][spec][2]["pointsSpent"] + self.playerData["talents"][spec][3]["pointsSpent"];
			if self.playerData["talents"][spec]["primaryTab"] then
				specNames[spec] = gGSETalentTreeData[self.playerData["class"]][self.playerData["talents"][spec]["primaryTab"]]["name"];
			end
			-- We're not gonna flag secondary specs unless the player is able to purchase duel specialization.
			if self.talentGroup == spec and (spec == 1 or self.playerData["level"] >= 40) then
				if pointsSpent < GSE_TalentPointsAtLevel(self.playerData["level"]) then
					specColors[spec] = "FFFF0000";
					missingTalents = true;
				else
					specColors[spec] = "FFFFFFFF";
				end
			elseif self.playerData["level"] >= 40 and pointsSpent < GSE_TalentPointsAtLevel(self.playerData["level"]) then
				specColors[spec] = "FFA00000";
			end
		end
		_G[self:GetName().."TabPage1PlayerTalentSpecs"]:SetFormattedText("|c%s%s: %d %d %d|cFFA0A0A0, |c%s%s: %d %d %d", specColors[1], specNames[1], self.playerData["talents"][1][1]["pointsSpent"], self.playerData["talents"][1][2]["pointsSpent"], self.playerData["talents"][1][3]["pointsSpent"], specColors[2], specNames[2], self.playerData["talents"][2][1]["pointsSpent"], self.playerData["talents"][2][2]["pointsSpent"], self.playerData["talents"][2][3]["pointsSpent"]);
	
		if missingTalents then
			talentAudit = "|cFFFF0000There are unplaced talent points in this spec.";
		end
	else
		_G[self:GetName().."TabPage1PlayerTalentSpecs"]:SetFormattedText("|cFFA0A0A0Talent data not gathered.");
	end

	_G[self:GetName().."TabPage1PlayerGearScore"]:SetText("|cFFF0F070GearScore: |cFFA0A0A0Unknown");
	_G[self:GetName().."TabPage1PlayerUpdateTime"]:SetText("");
	
	if self.playerData["inventory"] and self.playerData["inventory"][self.talentGroup] then
		local gearScore = GSE_GearScore(self.playerData, self.talentGroup);
		_G[self:GetName().."TabPage1PlayerGearScore"]:SetFormattedText("|cFFF0F070GearScore: %s%d", GSE_LightenedColorString(GSE_GearScoreColor(gearScore)), gearScore);
		local interval = time() - self.playerData["inventoryTime"][self.talentGroup];
		_G[self:GetName().."TabPage1PlayerUpdateTime"]:SetFormattedText("%sUpdated %s.", GSE_LightenedColorString(GSE_DirectGradientColor(interval, 60 * 60 * 24 * 7)), GSE_TimeIntervalString(interval));

		gearAudit = "|cFF00FF00All gear is equipped.";
		armorAudit = "|cFF00FF00All armor is within specialization.";
		gemAudit = "|cFF00FF00All gem slots are filled.";
		enchantAudit = "|cFF00FF00All gear is enchanted.";
		local gearedSlots = {
			["HeadSlot"] = false,
			["NeckSlot"] = false, 
			["ShoulderSlot"] = false, 
			["BackSlot"] = false, 
			["ChestSlot"] = false, 
			["WristSlot"] = false, 
			["HandsSlot"] = false, 
			["WaistSlot"] = false, 
			["LegsSlot"] = false, 
			["FeetSlot"] = false, 
			["Finger0Slot"] = false, 
			["Finger1Slot"] = false, 
			["Trinket0Slot"] = false, 
			["Trinket1Slot"] = false,
			["MainHandSlot"] = false,
			["SecondaryHandSlot"] = false,
			["RangedSlot"] = false,
		};
		for slot, item in pairs(self.playerData["inventory"][self.talentGroup]) do
			model:TryOn(item);
			local _, _, _, _, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(item);
			if slot ~= "BackSlot" and itemType == "Armor" and (itemSubType == "Cloth" or itemSubType == "Leather" or itemSubType == "Mail" or itemSubType == "Plate") then
				if itemSubType ~= armorSpecializations[self.playerData["class"]]["type"] then
					armorAudit = format("|cFFFF0000A piece of armor is outside specialization.");
				end
			end
			local totalGemSockets = GSE_TotalGemSockets(item);
			if itemEquipLoc == "INVTYPE_WAIST" then
				totalGemSockets = totalGemSockets + 1;
			end
			if GSE_TotalGems(item) < totalGemSockets then
				gemAudit = "|cFFFF0000There is a gem missing (it could be a belt buckle).";
			end
			local _, _, enchantId = strsplit(":", item);
			if enchantId == "0" and requiredEnchants[itemEquipLoc] then
				enchantAudit = "|cFFFF0000There is unenchanted gear.";
			end
			gearedSlots[slot] = true;
			if itemEquipLoc == "INVTYPE_2HWEAPON" then
				gearedSlots["SecondaryHandSlot"] = true;
			end
		end
		for k, v in pairs(gearedSlots) do
			if not v then
				gearAudit = "|cFFFF0000There is gear missing.";
				break
			end
		end
		if self.playerData["level"] < 40 then
			armorAudit = "|cFFA0A0A0Armor audits will begin at level 40.";
		end
	end
		
	_G[self:GetName().."TabPage1PlayerAudit"]:SetFormattedText("%s\n%s\n%s\n%s\n%s", gearAudit, armorAudit, gemAudit, enchantAudit, talentAudit);
		

	local raidBars = {
		{
			["name"] = "RubySanctum",
			["raid"] = "rs",
			["modes"] = {"10", "25"},
		},
		{
			["name"] = "RubySanctum (Heroic)",
			["raid"] = "rs",
			["modes"] = {"10h", "25h"},
		},
		{
			["name"] = "Icecrown Citadel",
			["raid"] = "icc",
			["modes"] = {"10", "25"},
		},
		{
			["name"] = "Icecrown Citadel (Heroic)",
			["raid"] = "icc",
			["modes"] = {"10h", "25h"},
		},
	}
	
	local barPrefix = self:GetName().."TabPage1RaidCompletionBar";
	for i = 1, 4 do
		local barData = raidBars[i];
		if barData and self.playerData["stats"] then
			_G[barPrefix..i]:Show();
			_G[barPrefix..i.."CompletionBarName"]:SetText(barData["name"]);
			local completion = GSE_PlayerCompletionPercentage(self.playerData, barData["raid"], barData["modes"]);
			_G[barPrefix..i.."CompletionBarValue"]:SetText(format("%d%%", completion * 100));
			_G[barPrefix..i.."CompletionBar"]:SetValue(completion);
			local red, green, blue = GSE_LightenedColor(GSE_DirectGradientColor(1.0 - completion));
			_G[barPrefix..i.."CompletionBar"]:SetStatusBarColor(red, green, blue);
			_G[barPrefix..i]:SetBackdropBorderColor(red * 0.4, green * 0.4, blue * 0.4, 1.0);
			_G[barPrefix..i].barData = barData;
			_G[barPrefix..i].playerData = self.playerData;
		else
			_G[barPrefix..i]:Hide();
		end
	end
end

function GSE_PlayerWindow_RaidCompletionBar_OnEnter(self)
	local red, green, blue, alpha = _G[self:GetName().."CompletionBar"]:GetStatusBarColor();
	self:SetBackdropBorderColor(red, green, blue, alpha);
	
	local tooltip = nil;
	
	if gGSEStatisticsInfo[self.barData["raid"]] and gGSEStatisticsInfo[self.barData["raid"]]["bosses"] then
		local bosses = gGSEStatisticsInfo[self.barData["raid"]]["bosses"];
		if #self.barData["modes"] == 2 then
			tooltip = LibQTip:Acquire("GSE_RaidCompletionTooltip", 3, "LEFT", "RIGHT", "RIGHT");
			self.tooltip = tooltip;
			if (self.barData["modes"][1] == "10" or self.barData["modes"][1] == "10h") and (self.barData["modes"][2] == "25" or self.barData["modes"][2] == "25h") then
				tooltip:AddHeader("|cFFF0F070Encounter", "|cFFF0F07010-Man", "|cFFF0F07025-Man");
			else
				tooltip:AddHeader("|cFFF0F070Encounter");
			end
			tooltip:AddSeparator(1, red, green, blue);
			for i = 1, #bosses do
				local mode1kills = GSE_PlayerBossKills(self.playerData, self.barData["raid"], bosses[i], {self.barData["modes"][1]});
				local mode2kills = GSE_PlayerBossKills(self.playerData, self.barData["raid"], bosses[i], {self.barData["modes"][2]});
				local r, g, b = GSE_DirectGradientColor(3 - GSE_Clamp(mode1kills + mode2kills, 0, 3), 3);
				local r1, g1, b1 = GSE_DirectGradientColor(3 - GSE_Clamp(mode1kills, 0, 3), 3);
				local r2, g2, b2 = GSE_DirectGradientColor(3 - GSE_Clamp(mode2kills, 0, 3), 3);
				tooltip:AddLine(format("%s%s", GSE_LightenedColorString(r, g, b), gGSEStatisticsInfo[self.barData["raid"]]["names"][bosses[i]]), format("%s%d", GSE_LightenedColorString(r1, g1, b1), mode1kills), format("%s%d", GSE_LightenedColorString(r2, g2, b2), mode2kills));
			end
		elseif #self.barData["modes"] == 1 then
			tooltip = LibQTip:Acquire("GSE_RaidCompletionTooltip", 2, "LEFT", "RIGHT");
			self.tooltip = tooltip;
			tooltip:AddHeader("|cFFF0F070Encounter");
			tooltip:AddSeparator(1, red, green, blue);
			for i = 1, #bosses do
				local kills = GSE_PlayerBossKills(self.playerData, self.barData["raid"], bosses[i], {self.barData["modes"][1]});
				local r, g, b = GSE_DirectGradientColor(GSE_Clamp(kills, 0, 3), 3);
				tooltip:AddLine(format("%s%s", GSE_LightenedColorString(r, g, b), gGSEStatisticsInfo[self.barData["raid"]]["names"][bosses[i]]), format("%s%d", GSE_LightenedColorString(r, g, b), kills));
			end
		end
	end
	
	if tooltip then
		tooltip:ClearAllPoints();
		tooltip:SetClampedToScreen(true);
		tooltip:SetPoint("BOTTOMLEFT", self, "TOPRIGHT");
		tooltip:Show();
	end
end

function GSE_PlayerWindow_RaidCompletionBar_OnLeave(self)
	local red, green, blue, alpha = _G[self:GetName().."CompletionBar"]:GetStatusBarColor();
	self:SetBackdropBorderColor(red * 0.4, green * 0.4, blue * 0.4, alpha);
	
	LibQTip:Release(self.tooltip);
	self.tooltip = nil;
end

function GSE_PlayerWindow_UpdateTalents(self)
	local talentButtonSize = TALENT_BUTTON_SIZE_DEFAULT;
	local initialOffsetX = 20;
	local initialOffsetY = 52;
	local buttonSpacingX = 46;
	local buttonSpacingY = 46;

	local talentTreeData = gGSETalentTreeData[self.playerData["class"]];
	if not talentTreeData then
		_G[self:GetName().."TabPage3Tree1"]:Hide();
		_G[self:GetName().."TabPage3Tree2"]:Hide();
		_G[self:GetName().."TabPage3Tree3"]:Hide();
	else
		_G[self:GetName().."TabPage3Tree1"]:Show();
		_G[self:GetName().."TabPage3Tree2"]:Show();
		_G[self:GetName().."TabPage3Tree3"]:Show();

		local talents = nil;
		
		if self.playerData["talents"] then
			talents = self.playerData["talents"][self.talentGroup];
		end

		for tree = 1, 3 do
			local treeFrame = self:GetName().."TabPage3Tree"..tree;
		
			_G[treeFrame.."BackgroundTopLeft"]:SetTexture("Interface\\TalentFrame\\"..talentTreeData[tree]["background"].."-TopLeft");
			_G[treeFrame.."BackgroundTopRight"]:SetTexture("Interface\\TalentFrame\\"..talentTreeData[tree]["background"].."-TopRight");
			_G[treeFrame.."BackgroundBottomLeft"]:SetTexture("Interface\\TalentFrame\\"..talentTreeData[tree]["background"].."-BottomLeft");
			_G[treeFrame.."BackgroundBottomRight"]:SetTexture("Interface\\TalentFrame\\"..talentTreeData[tree]["background"].."-BottomRight");

			_G[treeFrame.."Name"]:SetText(talentTreeData[tree]["name"]);
			
			if talents and tree == talents["primaryTab"] then
				_G[treeFrame.."GlowLeft"]:Show();
				_G[treeFrame.."GlowRight"]:Show();
				_G[treeFrame.."GlowBottomLeft"]:Show();
				_G[treeFrame.."GlowBottomRight"]:Show();
				_G[treeFrame.."GlowBottom"]:Show();
				_G[treeFrame.."GlowTopLeft"]:Show();
				_G[treeFrame.."GlowTopRight"]:Show();
				_G[treeFrame.."GlowTop"]:Show();
				
				_G[treeFrame.."HeaderIconPrimaryBorder"]:Show();
				_G[treeFrame.."HeaderIconSecondaryBorder"]:Hide();
				_G[treeFrame.."HeaderIconPointsSpentBgGold"]:Show();
				_G[treeFrame.."HeaderIconPointsSpentBgSilver"]:Hide();
			else
				_G[treeFrame.."GlowLeft"]:Hide();
				_G[treeFrame.."GlowRight"]:Hide();
				_G[treeFrame.."GlowBottomLeft"]:Hide();
				_G[treeFrame.."GlowBottomRight"]:Hide();
				_G[treeFrame.."GlowBottom"]:Hide();
				_G[treeFrame.."GlowTopLeft"]:Hide();
				_G[treeFrame.."GlowTopRight"]:Hide();
				_G[treeFrame.."GlowTop"]:Hide();

				_G[treeFrame.."HeaderIconPrimaryBorder"]:Hide();
				_G[treeFrame.."HeaderIconSecondaryBorder"]:Show();
				_G[treeFrame.."HeaderIconPointsSpentBgGold"]:Hide();
				_G[treeFrame.."HeaderIconPointsSpentBgSilver"]:Show();
			end
			
			-- Shadow
			if talents and not talents[tree]["isUnlocked"] and talents["primaryTab"] then
				_G[treeFrame.."InactiveShadow"]:Show();
				_G[treeFrame.."InactiveShadowGradient"]:Hide();
				_G[treeFrame.."InactiveShadowCover"]:SetPoint("TOPLEFT", 0, 0);
				_G[treeFrame.."InactiveShadow"]:SetAlpha(0.7);
			elseif talents and talents["primaryTab"] and talents["primaryTab"] ~= tree then
				_G[treeFrame.."InactiveShadow"]:Show();
				_G[treeFrame.."InactiveShadowGradient"]:Show();
				_G[treeFrame.."InactiveShadowCover"]:SetPoint("TOPLEFT", _G[treeFrame.."InactiveShadowGradient"], "BOTTOMLEFT", 0, 0);
				_G[treeFrame.."InactiveShadow"]:SetAlpha(0.5);
			else
				_G[treeFrame.."InactiveShadow"]:Hide();
			end
		
			-- Roles
			local role1 = talentTreeData[tree]["role1"];
			local role2 = talentTreeData[tree]["role2"];
			if (role1 == "TANK" or role1 == "HEALER" or role1 == "DAMAGER") then
				_G[treeFrame.."RoleIcon"]:SetTexCoord(GetTexCoordsForRoleSmall(role1));
				_G[treeFrame.."RoleIcon"]:Show();
			else
				_G[treeFrame.."RoleIcon"]:Hide();
			end
			
			if (role2 == "TANK" or role2 == "HEALER" or role2 == "DAMAGER") then
				_G[treeFrame.."RoleIcon2"]:SetTexCoord(GetTexCoordsForRoleSmall(role2));
				_G[treeFrame.."RoleIcon2"]:Show();
			else
				_G[treeFrame.."RoleIcon2"]:Hide();
			end

			local talentInfo = TALENT_INFO[self.playerData["class"]] or TALENT_INFO["default"];
			local color = talentInfo[tree].color;
			
			_G[treeFrame.."HeaderBackground"]:SetVertexColor(color.r, color.g, color.b);
			
			_G[treeFrame.."HeaderIcon"].name = talentTreeData[tree]["name"];
			_G[treeFrame.."HeaderIcon"].description = talentTreeData[tree]["description"];
			_G[treeFrame.."HeaderIconIcon"]:SetTexture(talentTreeData[tree]["iconTexture"]);
			
			if talents then
				_G[treeFrame.."HeaderIconPointsSpent"]:SetText(talents[tree]["pointsSpent"]);
			else
				_G[treeFrame.."HeaderIconPointsSpent"]:SetText("?");
			end

			if not _G[treeFrame].TALENT_BRANCH_ARRAY then
				TalentFrame_Load(_G[treeFrame]);
			end
			TalentFrame_ResetBranches(_G[treeFrame]);
			
			-- Talents
			for i = 1, 28 do
				local talentData = talentTreeData[tree][i];
				local buttonName = treeFrame.."Talent"..i;
				if talentData then					
					_G[treeFrame].TALENT_BRANCH_ARRAY[talentData["tier"]][talentData["column"]].id = i;

					local talentRank = 0;
					
					if talents and talents[tree] and talents[tree][i] then
						talentRank = talents[tree][i];
					end

					local prereqs = talentData["prereqs"];
					for j = 1, #prereqs do
						TalentFrame_DrawLines(talentData["tier"], talentData["column"], prereqs[j]["tier"], prereqs[j]["column"], talentRank > 0, _G[treeFrame]);
					end
					
					_G[buttonName]:SetPoint("TOPLEFT", initialOffsetX + (talentData["column"] - 1) * buttonSpacingX, -initialOffsetY - (talentData["tier"] - 1) * buttonSpacingY);
					_G[buttonName]:Show();

					_G[buttonName.."IconTexture"]:SetTexture(talentData["iconTexture"]);
					_G[buttonName]:SetPushedTexture(nil);
										
					if talentData[talentRank] then
						_G[buttonName].tooltipLink = talentData[talentRank];
					else
						_G[buttonName].tooltipLink = talentData[0];
					end
					
					_G[buttonName].talentName = talentData["name"];
					
					if talentData["isExceptional"] then
						_G[buttonName.."GoldBorder"]:Show();
					else
						_G[buttonName.."GoldBorder"]:Hide();
					end

					_G[buttonName.."RankBorderGreen"]:Hide();
					_G[buttonName.."RankBorder"]:Hide();
					
					if talentRank > 0 then
						_G[buttonName.."Rank"]:SetText(talentRank);
						if talentRank < talentData["maxRank"] then
							_G[buttonName.."Slot"]:SetVertexColor(0.1, 1.0, 0.1);
							_G[buttonName.."Rank"]:SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b);
							_G[buttonName.."RankBorderGreen"]:Show();
						else
							_G[buttonName.."Slot"]:SetVertexColor(1.0, 0.82, 0);
							_G[buttonName.."Rank"]:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
							_G[buttonName.."RankBorder"]:Show();
						end
						_G[buttonName.."IconTexture"]:SetDesaturated(false);
						_G[buttonName.."GoldBorder"]:SetDesaturated(false);
					else
						_G[buttonName.."Slot"]:SetVertexColor(0.5, 0.5, 0.5);
						_G[buttonName.."Rank"]:SetText("");
						_G[buttonName.."IconTexture"]:SetDesaturated(true);
						_G[buttonName.."GoldBorder"]:SetDesaturated(true);
					end
				else 
					_G[buttonName]:Hide();
				end
			end
			
			-- The following was originally copied from TalentFrameBase.lua
			-- Draw the prereq branches
			local node;
			local xOffset, yOffset;
			TalentFrame_ResetBranchTextureCount(_G[treeFrame]);
			TalentFrame_ResetArrowTextureCount(_G[treeFrame]);
			for i = 1, MAX_NUM_TALENT_TIERS do
				for j = 1, NUM_TALENT_COLUMNS do
					node = _G[treeFrame].TALENT_BRANCH_ARRAY[i][j];
					
					-- Setup offsets
					xOffset = ((j - 1) * buttonSpacingX) + initialOffsetX;
					yOffset = -((i - 1) * buttonSpacingY) - initialOffsetY;
					
					-- Always draw Right and Down branches, never draw Left and Up branches as those will be drawn by the preceeding talent
					if ( node.down ~= 0 ) then
						TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["down"][node.down], xOffset - 1, yOffset - talentButtonSize + 1, _G[treeFrame], talentButtonSize, buttonSpacingY - talentButtonSize);
					end
					if ( node.right ~= 0 ) then
						TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["right"][node.right], xOffset + talentButtonSize - 1, yOffset + 1, _G[treeFrame], buttonSpacingX - talentButtonSize, talentButtonSize);
					end
					
					if (node.id) then
						-- There is a talent in this slot; draw arrows
						local inset = 3;
						if talentTreeData[tree][node.id] and talentTreeData[tree][node.id]["isExceptional"] then
							inset = -2;
						end
						if ( node.rightArrow ~= 0 ) then
							TalentFrame_SetArrowTexture(i, j, TALENT_ARROW_TEXTURECOORDS["right"][node.rightArrow], xOffset + talentButtonSize / 2 + inset, yOffset, _G[treeFrame]);
						end
						if ( node.leftArrow ~= 0 ) then
							TalentFrame_SetArrowTexture(i, j, TALENT_ARROW_TEXTURECOORDS["left"][node.leftArrow], xOffset - talentButtonSize / 2 + inset, yOffset, _G[treeFrame]);
						end
						if ( node.topArrow ~= 0 ) then
							TalentFrame_SetArrowTexture(i, j, TALENT_ARROW_TEXTURECOORDS["top"][node.topArrow], xOffset, yOffset + talentButtonSize / 2 - inset, _G[treeFrame]);
						end
					else
						-- No talent; draw branches
						if ( node.up ~= 0 and node.left ~= 0 and node.right ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["tup"][node.up], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.down ~= 0 and node.left ~= 0 and node.right ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["tdown"][node.down], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.left ~= 0 and node.down ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["topright"][node.left], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.left ~= 0 and node.up ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["bottomright"][node.left], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.left ~= 0 and node.right ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["right"][node.right], xOffset + talentButtonSize - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.right ~= 0 and node.down ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["topleft"][node.right], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.right ~= 0 and node.up ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["bottomleft"][node.right], xOffset - 1, yOffset + 1, _G[treeFrame]);
						elseif ( node.up ~= 0 and node.down ~= 0 ) then
							TalentFrame_SetBranchTexture(i, j, TALENT_BRANCH_TEXTURECOORDS["up"][node.up], xOffset - 1, yOffset + 1, _G[treeFrame]);
						end
					end
				end
			end
			
			-- Hide any unused branch textures
			for i = TalentFrame_GetBranchTextureCount(_G[treeFrame]), MAX_NUM_BRANCH_TEXTURES do
				_G[treeFrame.."Branch"..i]:Hide();
			end
			-- Hide any unused arrow textures
			for i = TalentFrame_GetArrowTextureCount(_G[treeFrame]), MAX_NUM_ARROW_TEXTURES do
				_G[treeFrame.."Arrow"..i]:Hide();
			end
		end
	end
end